/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include "MCT.h"

void mainMCT(const tile_t * tile_in, tile_c_t * tile_out)
{
	int i;
	int r, g, b, y, u, v;
	int size = WIDTH_TILE * HEIGHT_TILE;
	
	tile_out->num = tile_in->num;
	tile_out->numcomp = NumComp;
	
	switch(NumComp)
	{
		case 0:
			for(i = 0; i < size; i++)
			{
				r = tile_in->comp[0][i];
				g = tile_in->comp[1][i];
				b = tile_in->comp[2][i];
				
				y = (r + (g << 1) + b) >> 2;
				
#ifndef INTEGER_TILES
				// MA-a: To check also with other images...
				if (y > 127) y = 127;
				else if (y < -128) y = -128;
#endif
				tile_out->comp[i] = y;
				NumComp = 1;

			}
		break;
		case 1:
			for(i = 0; i < size; i++)
			{
				g = tile_in->comp[1][i];
				b = tile_in->comp[2][i];
				
				u = b - g;
				
#ifndef INTEGER_TILES
				// MA-a: To check also with other images...

				if (u > 127) u = 127;
				else if (u < -128) u = -128;
#endif
				tile_out->comp[i] = u;
				NumComp = 2;
			}
		break;
		case 2:
			for(i = 0; i < size; i++)
			{
				r = tile_in->comp[0][i];
				g = tile_in->comp[1][i];
				
				v = r - g;
				
#ifndef INTEGER_TILES
				// MA-a: To check also with other images...
				if (v > 127) v = 127;
				else if (v < -128) v = -128;
#endif
				tile_out->comp[i] = v;
				NumComp = 0;
			}
		break;
		default:
		break;
	}
}
