/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef P_8_H
#define P_8_H

#include "math.h"
#include "yapi.h"

#include "aux_func.h"
#include <iostream>


class P_8 : public Process {
  private:

    // Input Gates and controllers
    InPort<tCH_9> IG_1;

    // Output Gates

    // Parameters

    // Input Arguments 
    tCH_9 in_0ND_7;

    // Output Arguments 

  public:

    // Constructor 
    P_8(Id n,
    In<tCH_9>& IG_1_instance) :
    Process(n),
    IG_1(id("IG_1"), IG_1_instance )
    {
    }; 

    const char* type() const {return "P_8";};

    void main() {

      for( int c0 =  ceil1(0); c0 <=  floor1(63 ); c0 += 1 ) {
        for( int c1 =  ceil1(0); c1 <=  floor1(2 ); c1 += 1 ) {
            read(IG_1, in_0ND_7);


            _mainVideoOut(in_0ND_7) ;
            execute("_mainVideoOut");

        } // for c1
      } // for c0

    } // main
};

#endif
