/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef aux_func_H
#define aux_func_H

#include <math.h>
#include "jpeg2000_func.h"

typedef struct tile_t tCH_1;
typedef struct tile_c_t tCH_2;
typedef struct tile_c_t tCH_3;
typedef struct tile_c_t tCH_4;
typedef struct tile_c_t tCH_5;
typedef struct code_pas_t tCH_6;
typedef struct code_pas_t tCH_7;
typedef struct code_pas_t tCH_8;
typedef struct packet_t tCH_9;

inline
void  _mainVideoIn( tCH_1 &out_0 ) {
    mainVideoIn( &out_0 );
}

inline
void  _mainMCT( tCH_1 in_0, tCH_2 &out_1 ) {
    mainMCT( &in_0, &out_1 );
}

inline
void  _mainDWT( tCH_2 in_0, tCH_5 &out_1 ) {
    mainDWT( &in_0, &out_1 );
}

inline
void  _mainT1( tCH_3 in_0, tCH_6 &out_1 ) {
    mainT1( &in_0, &out_1 );
}

inline
void  _mainT2( tCH_8 in_0, tCH_9 &out_1 ) {
    mainT2( &in_0, &out_1 );
}

inline
void  _mainVideoOut( tCH_9 in_0 ) {
    mainVideoOut( &in_0 );
}


inline
double min( double a, double b ){
  if ( a>=b )  {
    return b;
  } else {
    return a;
  }
}

inline
double max( double a, double b ){
  if ( a>=b )  {
    return a;
  } else {
    return b;
  }
}

inline
int ddiv( double a, double b ){

    //return (int)(a/b);
    return ( (int) (((a)<0) ? ((a)-(b)+1)/(b) : (a)/(b)) ); 
    //return ( (int) (((a)<0)^((b)<0) ? ((a) < 0 ? ((a)-(b)+1)/(b) : ((a)-(b)-1)/(b)) : (a)/(b)) ); 
}

inline
int mod( double a, double b ){

    return (int)fmod(a, b);
}

inline
int ceil1( double a ){

    return (int) ceil(a);
}

inline
int floor1( double a ){

    return (int) floor(a);
}


#endif
