/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef DWT_H_
#define DWT_H_

#include "jpeg2000_func.h"

#define S(i) a[(i)*2]
#define D(i) a[(1+(i)*2)]
#define S_(i) ((i)<0?S(0):((i)>=sn?S(sn-1):S(i)))
#define D_(i) ((i)<0?D(0):((i)>=dn?D(dn-1):D(i)))

#define SS_(i) ((i)<0?S(0):((i)>=dn?S(dn-1):S(i)))
#define DD_(i) ((i)<0?D(0):((i)>=sn?D(sn-1):D(i)))

int RES_WIDTH[NUM_RES_MAX] = {WIDTH_TILE/8, WIDTH_TILE/4, WIDTH_TILE/2, WIDTH_TILE};
int RES_HEIGTH[NUM_RES_MAX] = {HEIGHT_TILE/8, HEIGHT_TILE/4, HEIGHT_TILE/2, HEIGHT_TILE};

#ifdef INTEGER_TILES
static void dwt_encode(int * out, int);
static void dwt_encode_1(int *a, int dn, int sn, int cas);
static void dwt_deinterleave_h(int *a, int *b, int dn, int sn, int cas);
static void dwt_deinterleave_v(int *a, int *b, int dn, int sn, int x, int cas);
#else
static void dwt_encode(char * out, int);
static void dwt_encode_1(char *a, int dn, int sn, int cas);
static void dwt_deinterleave_h(char *a, char *b, int dn, int sn, int cas);
static void dwt_deinterleave_v(char *a, char *b, int dn, int sn, int x, int cas);
#endif


#endif /*DWT_H_*/

