/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "VideoIn.h"

void mainVideoIn(tile_t * tile_out)
{
	int p, q, tx0, ty0, i, k, j;
	
	tile_out->num = num;

#ifdef PC 	// Read the image once


	if (num == 0)
	{
		char name[MAX_NAME];
		strcpy(name,FILE_NAME);

		//*
		strcat(name,".bmp");	
		bmptoimage(name);

		// To generate 3 component images
		//FILE *f;
		//strcpy(name,FILE_NAME);
		//strcat(name,".R");
		//f = fopen(name,"wb");
		//fwrite(Rtable,4,WIDTH_IMAGE * HEIGHT_IMAGE/4,f);
		//fclose(f);
		//strcpy(name,FILE_NAME);
		//strcat(name,".G");
		//f = fopen(name,"wb");
		//fwrite(Gtable,4,WIDTH_IMAGE * HEIGHT_IMAGE/4,f);
		//fclose(f);
		//strcpy(name,FILE_NAME);
		//strcat(name,".B");
		//f = fopen(name,"wb");
		//fwrite(Btable,4,WIDTH_IMAGE * HEIGHT_IMAGE/4,f);
		//fclose(f);

		/*/
		FILE *f;
		
		strcpy(name,FILE_NAME);
		strcat(name,".R");
		f = fopen(name,"rb");
		fread(Rtable, 4, WIDTH_IMAGE * HEIGHT_IMAGE / 4, f);
		fclose(f);

		strcpy(name,FILE_NAME);
		strcat(name,".G");
		f = fopen(name,"rb");
		fread(Gtable, 4, WIDTH_IMAGE * HEIGHT_IMAGE / 4, f);
		fclose(f);

		strcpy(name,FILE_NAME);
		strcat(name,".B");
		f = fopen(name,"rb");
		fread(Btable, 4, WIDTH_IMAGE * HEIGHT_IMAGE / 4, f);
		fclose(f);
		//*/
	}
#endif
	
	p = num % HTILES;
	q = num / HTILES;
	
	tx0 = p * WIDTH_TILE;
	ty0 = q * HEIGHT_TILE;

	// Copy the tile part from the whole image
	
	if(CUR_TP_NUM == 0){
		for (i = 0; i< NUM_COMPS; i++)
		{
			int adjust = SIGN ? 0 : 1 << (PRECISION - 1);
			for (j = ty0; j < ty0 + HEIGHT_TILE; j++)
			{
				int * data;
				switch(i)
				{
					case 0: data = (int*) &Rtable[tx0/4 + (j * WIDTH_TILE * HTILES/4)];
					break;
					case 1: data = (int*) &Gtable[tx0/4 + (j * WIDTH_TILE * HTILES/4)];
					break;
					case 2: data = (int*) &Btable[tx0/4 + (j * WIDTH_TILE * HTILES/4)];
					break;
					default:
					break;
				}
#ifdef INTEGER_TILES
				int *tile_data = &(tile_out->comp[i][(j - ty0) * WIDTH_TILE]);
#else 
				char *tile_data = &(tile_out->comp[i][(j - ty0) * WIDTH_TILE]);
#endif						 
 				for (k = tx0/4; k < tx0/4 + WIDTH_TILE/4; k++)
				{
					*tile_data++ = (*data & 0x000000FF) - adjust;
					*tile_data++ = ((*data >> 8) & 0x000000FF) - adjust;
					*tile_data++ = ((*data >> 16) & 0x000000FF) - adjust;
					*tile_data++ = ((*data++ >> 24) & 0x000000FF) - adjust;
				}	
			}
		}
	}
	num ++;
}

#ifdef PC 
void bmptoimage(const char *filename)
{
	int w, h;
	FILE *IN;
	BITMAPFILEHEADER_t File_h;
	BITMAPINFOHEADER_t Info_h;
	unsigned char *RGB;
	unsigned int PAD = 0;
	int x, y, index;
	DWORD W, H;
    int fill;
    
	IN = fopen(filename, "rb");
	
	File_h.bfType = getc(IN);
	File_h.bfType = (getc(IN) << 8) + File_h.bfType;
	
	if (File_h.bfType != 19778) {
		//return 0;
	} else {
		// FILE HEADER

		File_h.bfSize = getc(IN);
		File_h.bfSize = (getc(IN) << 8) + File_h.bfSize;
		File_h.bfSize = (getc(IN) << 16) + File_h.bfSize;
		File_h.bfSize = (getc(IN) << 24) + File_h.bfSize;

		File_h.bfReserved1 = getc(IN);
		File_h.bfReserved1 = (getc(IN) << 8) + File_h.bfReserved1;

		File_h.bfReserved2 = getc(IN);
		File_h.bfReserved2 = (getc(IN) << 8) + File_h.bfReserved2;

		File_h.bfOffBits = getc(IN);
		File_h.bfOffBits = (getc(IN) << 8) + File_h.bfOffBits;
		File_h.bfOffBits = (getc(IN) << 16) + File_h.bfOffBits;
		File_h.bfOffBits = (getc(IN) << 24) + File_h.bfOffBits;

		// INFO HEADER 

		Info_h.biSize = getc(IN);
		Info_h.biSize = (getc(IN) << 8) + Info_h.biSize;
		Info_h.biSize = (getc(IN) << 16) + Info_h.biSize;
		Info_h.biSize = (getc(IN) << 24) + Info_h.biSize;

		Info_h.biWidth = getc(IN);
		Info_h.biWidth = (getc(IN) << 8) + Info_h.biWidth;
		Info_h.biWidth = (getc(IN) << 16) + Info_h.biWidth;
		Info_h.biWidth = (getc(IN) << 24) + Info_h.biWidth;
		w = Info_h.biWidth;

		Info_h.biHeight = getc(IN);
		Info_h.biHeight = (getc(IN) << 8) + Info_h.biHeight;
		Info_h.biHeight = (getc(IN) << 16) + Info_h.biHeight;
		Info_h.biHeight = (getc(IN) << 24) + Info_h.biHeight;
		h = Info_h.biHeight;

		Info_h.biPlanes = getc(IN);
		Info_h.biPlanes = (getc(IN) << 8) + Info_h.biPlanes;

		Info_h.biBitCount = getc(IN);
		Info_h.biBitCount = (getc(IN) << 8) + Info_h.biBitCount;

		Info_h.biCompression = getc(IN);
		Info_h.biCompression = (getc(IN) << 8) + Info_h.biCompression;
		Info_h.biCompression = (getc(IN) << 16) + Info_h.biCompression;
		Info_h.biCompression = (getc(IN) << 24) + Info_h.biCompression;

		Info_h.biSizeImage = getc(IN);
		Info_h.biSizeImage = (getc(IN) << 8) + Info_h.biSizeImage;
		Info_h.biSizeImage = (getc(IN) << 16) + Info_h.biSizeImage;
		Info_h.biSizeImage = (getc(IN) << 24) + Info_h.biSizeImage;

		Info_h.biXpelsPerMeter = getc(IN);
		Info_h.biXpelsPerMeter = (getc(IN) << 8) + Info_h.biXpelsPerMeter;
		Info_h.biXpelsPerMeter = (getc(IN) << 16) + Info_h.biXpelsPerMeter;
		Info_h.biXpelsPerMeter = (getc(IN) << 24) + Info_h.biXpelsPerMeter;

		Info_h.biYpelsPerMeter = getc(IN);
		Info_h.biYpelsPerMeter = (getc(IN) << 8) + Info_h.biYpelsPerMeter;
		Info_h.biYpelsPerMeter = (getc(IN) << 16) + Info_h.biYpelsPerMeter;
		Info_h.biYpelsPerMeter = (getc(IN) << 24) + Info_h.biYpelsPerMeter;

		Info_h.biClrUsed = getc(IN);
		Info_h.biClrUsed = (getc(IN) << 8) + Info_h.biClrUsed;
		Info_h.biClrUsed = (getc(IN) << 16) + Info_h.biClrUsed;
		Info_h.biClrUsed = (getc(IN) << 24) + Info_h.biClrUsed;

		Info_h.biClrImportant = getc(IN);
		Info_h.biClrImportant = (getc(IN) << 8) + Info_h.biClrImportant;
		Info_h.biClrImportant = (getc(IN) << 16) + Info_h.biClrImportant;
		Info_h.biClrImportant = (getc(IN) << 24) + Info_h.biClrImportant;

		// Read the data and store them in the OUT file
    
		if (Info_h.biBitCount == 24) {

			//Place the cursor at the beginning of the image information
			fseek(IN, 0, SEEK_SET);
			fseek(IN, File_h.bfOffBits, SEEK_SET);
			
			W = Info_h.biWidth;
			H = Info_h.biHeight;

			PAD = (3 * W) % 4 ? 4 - (3 * W) % 4 : 0;
			
			RGB = (unsigned char *) malloc((3 * W + PAD) * H * sizeof(unsigned char));
			
			fread(RGB, sizeof(unsigned char), (3 * W + PAD) * H, IN);
			
			index = 0;
			fill = 0;
			
			for(y = 0; y < (int)H; y++) {
				unsigned char *scanline = RGB + (3 * W + PAD) * (H - 1 - y);
				for(x = 0; x < (int)W; x++) {
					unsigned char *pixel = &scanline[3 * x];
					switch(fill)
					{
						case 0:
							Rtable[index] = pixel[2];
							Gtable[index] = pixel[1];
							Btable[index] = pixel[0];
							fill = 1;
						break;
						case 1:
							Rtable[index] |= (pixel[2]) << 8;
							Gtable[index] |= (pixel[1]) << 8;
							Btable[index] |= (pixel[0]) << 8;
							fill = 2;
						break;
						case 2:
							Rtable[index] |= (pixel[2]) << 16;
							Gtable[index] |= (pixel[1]) << 16;
							Btable[index] |= (pixel[0]) << 16;
							fill = 3;
						break;	
						case 3:
							Rtable[index] |= (pixel[2]) << 24;
							Gtable[index] |= (pixel[1]) << 24;
							Btable[index] |= (pixel[0]) << 24;
							fill = 0;
							index++;
						break;			
					}
				}
			}

			free(RGB);
		}
		fclose(IN);
	}
}
#endif
