/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#ifndef VIDEOIN_H_
#define VIDEOIN_H_

#include "jpeg2000_func.h"
#ifndef PC
#include "MemoryMap.h"
#endif

typedef unsigned short int WORD;
typedef unsigned long int DWORD;

typedef struct image_t{
	int * data[NUM_COMPS];
} image_t;

typedef struct {
  WORD bfType;			// 'BM' for Bitmap (19776)
  DWORD bfSize;			// Size of the file
  WORD bfReserved1;		// Reserved : 0
  WORD bfReserved2;		// Reserved : 0
  DWORD bfOffBits;		// Offset
} BITMAPFILEHEADER_t;

typedef struct {
  DWORD biSize;			// Size of the structure in bytes
  DWORD biWidth;		// Width of the image in pixels
  DWORD biHeight;		// Heigth of the image in pixels
  WORD biPlanes;		// 1
  WORD biBitCount;		// Number of color bits by pixels
  DWORD biCompression;		// Type of encoding 0: none 1: RLE8 2: RLE4
  DWORD biSizeImage;		// Size of the image in bytes
  DWORD biXpelsPerMeter;	// Horizontal (X) resolution in pixels/meter
  DWORD biYpelsPerMeter;	// Vertical (Y) resolution in pixels/meter
  DWORD biClrUsed;			// Number of color used in the image (0: ALL)
  DWORD biClrImportant;		// Number of important color (0: ALL)
} BITMAPINFOHEADER_t;

static int num = 0;

#ifdef PC
static int Rtable[WIDTH_IMAGE * HEIGHT_IMAGE / 4];
static int Gtable[WIDTH_IMAGE * HEIGHT_IMAGE / 4];
static int Btable[WIDTH_IMAGE * HEIGHT_IMAGE / 4];
#else
static volatile int *Rtable = ZBT_MEM;
static volatile int *Gtable = (volatile int *) (ZBT_MEM + (WIDTH_IMAGE * HEIGHT_IMAGE / 4));
static volatile int *Btable = (volatile int *) (ZBT_MEM + (2 * (WIDTH_IMAGE * HEIGHT_IMAGE / 4)));
#endif

#ifdef PC 
void bmptoimage(const char *filename);
#endif

#endif /*VIDEOIN_H_*/

