/*******************************************************************\

Copyright (c) 2008 Leiden University (LERC group at LIACS).
All rights reserved.

The use and distribution terms for this software are covered by the 
Common Public License 1.0 (http://opensource.org/licenses/cpl1.0.txt)
which can be found in the file LICENSE at the root of this distribution.
By using this software in any fashion, you are agreeing to be bound by 
the terms of this license.

You must not remove this notice, or any other, from this software.

\*******************************************************************/

#include "jpeg2000_func.h"

int main (int argc, char **argv)
{
	int i,j;
	tile_t tile;
	tile_c_t tilec;
	code_pas_t codepas;
	packet_t packets;
		
	for (i = 0; i < NUMTILES; i++)
	{
		mainVideoIn(&tile);							//Code for each Tile

		for (j = 0; j < NUM_COMPS; j++)
		{
			mainMCT(&tile,&tilec);						//RGB to YUV transform
			mainDWT(&tilec,&tilec);						//Wavelet transform
                        if (j % 3 == 0) {
			  mainT1(&tilec,&codepas);                                      //Tier-1 arithmetic encoding
                        }					                        
                        if (j % 3 == 1) {
			  mainT1(&tilec,&codepas);                                      //Tier-1 arithmetic encoding
                        }					                        
                        if (j % 3 == 2) {
			  mainT1(&tilec,&codepas);                                      //Tier-1 arithmetic encoding
                        }					                        
			mainT2(&codepas,&packets);					//Tier-2 packetisation
			mainVideoOut(&packets);						//File Generation
		}
	}
		
	return 0;
}

